@echo off
setlocal DISABLEDELAYEDEXPANSION
set ext=*.mp4;*.avi;*.mkv;*.flv;*.mov;*.mpeg;*.mpg;*.rm;*.rmvb;*.vob;*.wmv;*.tp;*.ts;*.mts;*.m2ts;*.divx;*.3gp;*.asf

SET begin_time=%time%
set tf=.%random%-%random%-%random%.tmp
SET isechoc=1
FOR /F %%i IN ("echoc.exe") DO set echoccmd=%%~$PATH:i
IF not defined echoccmd SET isechoc=0
set /p a=<nul>%tf% 2>nul
for %%i in (%ext%) do (set /p a=A<nul >>%tf%)
FOR /F "delims=" %%s IN ('dir /b %tf%') DO set /p a=%%~zs>%tf%.len<nul
set /p total=<%tf%.len

set /p a=<nul>%tf% 2>nul
for %%i in (%ext%) do (set /p a=A<nul>>%tf%
	FOR /F "delims=" %%s IN ('dir /b %tf%') DO (
		SET /p a= _ <nul
		IF %isechoc%==1 (echoc 0E %%~zs/%total%) else (echo %%~zs/%total%)
		SET /p a= _ <nul
		call time>%tf%.time<nul 2>nul
		type %tf%.time|find "." 2>nul
		)
	call Make_Thumbnail -ns "%%i" %*
	ECHO.
	)
SET end_time=%time%

call :Fun_CalculateTotalTime %begin_time% %end_time%
SET begin_time=%begin_time: =%
SET end_time=%end_time: =%
SET /p a= total time     %begin_time% - %end_time% = <nul
IF %isechoc%==1 (echoc 0C "%total_time%") else (echo %total_time%)
del %tf% 2>nul
del %tf%.len 2>nul
del %tf%.time 2>nul
exit /b

::------------------------------Fun_CalculateTotalTime-----------------------
:: Revision : 1.0.3
::     Date : 2012-09-30
::  Created : 2012-05-19
::  Purpose : Calculate time
::    usege : call :Fun_CalculateTotalTime 01:02:03.400 04:03:10.510 [display]
:: results in TOTAL_TIME Environment variables
::------------------Calculate the total time---------------------------------
::                        012345678901
:: SET      start_pos_tmp=01:02:03.400
:: SET        end_pos_tmp=04:03:10.511
:Fun_CalculateTotalTime
SET start_pos_tmp=%1
SET end_pos_tmp=%2

IF "%start_pos_tmp:~1,1%"==":" SET "start_pos_tmp=0%start_pos_tmp%"
IF "%end_pos_tmp:~1,1%"==":" SET "end_pos_tmp=0%end_pos_tmp%"

SET hour=%start_pos_tmp:~0,2%
SET min=%start_pos_tmp:~3,2%
SET sec=%start_pos_tmp:~6,2%
SET msec=%start_pos_tmp:~9,2%0

rem --------for skip 08 09---------------
IF %hour:~0,1%==0  SET hour=%hour:~1,1%
IF %min:~0,1%==0   SET min=%min:~1,1%
IF %sec:~0,1%==0   SET sec=%sec:~1,1%
IF %msec:~0,1%==0  SET msec=%msec:~1,2%
IF %msec:~0,1%==0  SET msec=%msec:~1,1%

SET /a hour=%hour%
SET /a min=%min%
SET /a sec=%sec%
SET /a msec=%msec%

SET /a start_millsec=%hour%*60*60+%min%*60+%sec%
SET /a start_millsec=%start_millsec%*1000+%msec%

SET ehour=%end_pos_tmp:~0,2%
SET emin=%end_pos_tmp:~3,2%
SET esec=%end_pos_tmp:~6,2%
SET emsec=%end_pos_tmp:~9,2%0

rem --------for skip 08 09---------------
IF %ehour:~0,1%==0  SET ehour=%ehour:~1,1%
IF %emin:~0,1%==0   SET emin=%emin:~1,1%
IF %esec:~0,1%==0   SET esec=%esec:~1,1%
IF %emsec:~0,1%==0  SET emsec=%emsec:~1,2%
IF %emsec:~0,1%==0  SET emsec=%emsec:~1,1%

SET /a ehour=%ehour%
SET /a emin=%emin%
SET /a esec=%esec%
SET /a emsec=%emsec%

SET /a end_millsec=%ehour%*60*60+%emin%*60+%esec%
SET /a end_millsec=%end_millsec%*1000+%emsec%
SET /a total_time_millsec=%end_millsec%-%start_millsec%
SET /a tsec=%total_time_millsec%/1000
SET /a tmsec=%total_time_millsec%-%tsec%*1000
SET /a tmin=%tsec%/60
SET /a tsec=%tsec%-%tmin%*60
SET /a thour=%tmin%/60
SET /a tmin=%tmin%-%thour%*60

IF %thour% LEQ 9 (SET thour=0%thour%)
IF %tmin%  LEQ 9 (SET tmin=0%tmin%)
IF %tsec%  LEQ 9 (SET tsec=0%tsec%)
IF %tmsec%  LEQ 9 (SET tmsec=00%tmsec%) else (IF %tmsec%  LEQ 99 (SET tmsec=0%tmsec%))
SET total_time=%thour%:%tmin%:%tsec%.%tmsec:~0,2%
IF "%3"=="display" (echo [%start_pos_tmp% - %end_pos_tmp%] = %total_time%)
EXIT /b
::------------------Calculate the total time---------------------------------